<template>
    <Modal
        title="Second modal (with form)"
        @close="$emit('close')"
    >
        <!-- body -->
        <div slot="body">
            <form action="" @submit.prevent="onSubmit">
                <div
                    class="form-item"
                    :class="{ errorInput: $v.name.$error }"
                >
                    <label>Name:</label>
                    <p class="errorText" v-if="!$v.name.required">Field is required!</p>
                    <p class="errorText" v-if="!$v.name.minLength">Minimal length {{ $v.name.$params.minLength.min }}!</p>
                    <input
                        v-model="name"
                        :class="{ error: $v.name.$error }"
                        @change="$v.name.$touch()"
                    />
                </div>
                <div
                    class="form-item"
                    :class="{ errorInput: $v.email.$error}"
                >
                    <label>Email:</label>
                    <p class="errorText" v-if="!$v.email.required">Field is required!</p>
                    <p class="errorText" v-if="!$v.email.email">Must be correct Email!</p>
                     <input
                        v-model="email"
                        :class="{ error: $v.email.$error }"
                        @change="$v.email.$touch()"
                    />
                </div>
                <hr>
                <button class="btn btnPrimary">Submit</button>
            </form>
        </div>
    </Modal>
</template>

<script>
import { required, minLength, email } from 'vuelidate/lib/validators'
import Modal from '@/components/UI/Modal.vue'

export default {
    components: {
        Modal,
    },
    data() {
        return {
            name: '',
            email: '',
        }
    },
    validations: {
        name: {
            required,
            minLength: minLength(4)
        },
        email: {
            required,
            email
        }
    },
    methods: {
        onSubmit() {
            this.$v.$touch();
            if(!this.$v.$invalid){
                const user = {
                    name: this.name,
                    email: this.email
                }
                console.log(user)
            }
            this.name = '';
            this.email = '';
            this.$v.$reset();
            this.$emit('close')
        }
    }
}
</script>

<style lang="scss">
@import '@/assets/scss/utils/vars.scss';
.form-item .errorText {
    display: none;
    margin-bottom: 8px;
    font-size: 13.4px;
    color: $danger-color ;
}
.form-item {
    &.errorInput .errorText {
        display: block;
    }
}
input.error {
    border-color: $danger-color;
}
</style>